Xilinx EFCT Linux network driver
===================================
Version:  v1.4.0.0

Overview
--------
This package is the Linux NET driver source RPM/DEB for Xilinx X3 series adapters.

Documentation
-------------

Supported hardware platforms
----------------------------
The drivers contained in this package support the following Xilinx
adapter:

- Xilinx X3522 card

Installation Prerequisite
--------------------------
Please install auxiliary RPM/DEB package if there is no in-tree auxiliary bus support before proceeding to install net driver.

Building and installation of RPM packages
-----------------------------------------

To build a binary RPM for the running kernel type:
  rpmbuild --rebuild <source rpm filename>

To install the resulting binary rpm:
  Locate the file that was created in the preceding step, prefixed with the
  annotation "Wrote:", usually it is in the <RPM top directory>/RPMS/
  then type:
    rpm -Uvh <binary rpm filename>

Building and installation of Debian packages
---------------------------------------------
To install a debian use:
	dpkg -i <debian package>

Loading and verifying Driver version
------------------------------------

To ensure that the correct version of the driver is loaded into the current kernel
   /sbin/modprobe -r xilinx_efct
   /sbin/modprobe xilinx_efct

Installation of the driver can be confirmed by typing:
   modinfo xilinx_efct | grep version
and checking for the line:
   version: v1.4.0.0

All network interfaces available on the system can be found with:
  ifconfig -a

Linux distribution support for Xilinx Adapters
--------------------------------------------------

This driver package is supported on:
 - RedHat Enterprise Linux                        7.8, 7.9
 - RedHat Enterprise Linux                        8.2, 8.4, 8.5, 8.6, 8.7
 - RedHat Enterprise Linux                        9.0, 9.1
 - Canonical Ubuntu Server LTS                    20.04, 22.04
 - SuSE Linux Enterprise Server 15                sp2, sp3, sp4
 - Debian 10 "Buster"
 - Debian 11 "Bullseye"
 - Linux kernels 4.15 - 5.18

Changelog
---------
### v1.4.0.0
[General changes]
 ~ fixes checkpatch, cppcheck, sparse errors

Issue XNET-469:
 ~ Pass design params to aux client.

Issue XNET-468:
 ~ Avoid converting scaled ppm to integral ppb.

Issue XNET-475:
 ~ Fix possible deadlock in hwmon state change event.

Issue XNET-194:
 ~ Add ETHER_FLOW ethtool type and PARSER_DISP_INFO validation.

Issue XNET-510:
 ~ Obtain unique ID's for auxiliary device using ida_alloc_range

Issue XNET-486:
 ~ Use design param value for no of filter.

Issue XNET-485:
 ~ Calculate no of queue required during driver probe.

### v1.3.1.0
[General changes]
 ~ fixes to support 5.18 upstream kernel
 ~ fixes checkpatch, cppcheck, sparse errors

Issue X3-1303
 ~ Allow reset scheduling in UP/DOWN nic state only. otherwise
   pci_reset_function() can deadlock if driver reset in probe state.

Issue X3-1273
 ~ Add PCI shutdown callback to clear hw resources during reboot

Issue XNET-461
 ~ Fix race in separate decrement and read operation

Issue ON-14533
 ~ Fix xilinx_efct refcount leak

Issue XNET-429
 ~ Change MSIX allocation scheme as per latest updates in 5.18 kernel.

Issue XNET-441
 ~ Fix return value for get_sset_count ethtool API.

### v1.2.5.0
Issue X3-1211
 ~ Use kernel API to copy mac addr to netdev->dev_addr

Issue X3-1211
 ~ Use DMA_BIDIRECTIONAL flag instead of PCI_DMA_BIDIRECTIONAL

### v1.2.4.0
Issue ON-14405
 ~ avoid races in huge page list update

### v1.2.3.0
Issue  XNET-422: Enable RX_CLS_LOC_SPECIAL for ethtool filter support
 ~ X3 driver supports special location values. ethtool command
   with explict filter will fail after this change.

Issue XNET-420
 ~ Set destination IP for multicast filter and update filter error
   reported in dmesg logs.

Issue XNET-414
 ~ Include base and limit index for tx queue in AUX interface

Issue X3-1176
 ~ Reset sync_events_state in ev_init

Issue X3-1034
 ~ Reading boot count from FCW to avoid MCDI timeout after MC reboot

Issue XNET-418
 ~ In case filter is matched and CONFIG_XILINX_AUX_EFCT=n, let stack handle
   received packets.

### v1.2.0.0
Issue XNET-271
 ~ Add support for ethtool selftests

Issue X3-1096
 ~ Replace "fw.usercfg" in devlink dev info output with fw.psid
   and include version only if it non zero and valid flag is set.

Issue X3-1042
 ~ FW sets IRQ moderation timer value in multiple of 1024 nanos.
   Use DIV_ROUND_CLOSEST to get more accurate value.

Issue XNET-402
 ~ Add ndo callback to read stats while holding lock.

Issue X3-1008
 ~ Rename pps stats variable

Issue X3-1028
 ~ Enable Interrupts after checking link state in net_open.

### v1.0.8.0
 ~ Initial version

Copyright
---------
Copyright 2021-2023 Xilinx Inc.
All rights reserved. Use is subject to license terms.
